#include "IR.h"
#include "delay.h"
 bit   P_IR_RX_temp;                //Last sample
 bit    B_IR_Sync;                        //已收到同步标志
 u8        IR_SampleCnt;                //采样计数
 u8        IR_BitCnt;                        //编码位数
 u8        IR_UserH;                        //用户码高字节
 u8        IR_UserL;                        //用户码低字节
 u8        IR_data;                        //数据源码
 u8        IR_DataShit;                //数据反码
 u8        drive_st  ;                  //驱动状态 
 int       delay_cut  ;                 //延时计数
 bit    B_IrUserErr;                //User code error flag
 bit    B_IR_Press;                        //Key press flag,include repeat key.
 u8        IR_code;                        //IR code        红外码键
/*************红外开始帧********************/
void Send_Start_Bit(void)    //TR1??=?????24mhz
{
        
        TR1=1;
        Delay8295us();
        TR1=0;
        IR_OUT=1;
        Delay4146us();
        IR_OUT=1;
}
/**********红外写0**************************/
void Send_Bit_0(void)
{          
        TR1=1;
        Delay521us();
		TR1=0;
        IR_OUT=1;
		 Delay521us();
        IR_OUT=1;
}
/*************红外写1*************************/
void Send_Bit_1(void)
{
        TR1=1;
        Delay521us();
		TR1=0;
        IR_OUT=1;
        Delay1563us();
        IR_OUT=1;  
}
/****************红外结束帧****************************/
void Send_over(void)            //
{
        TR1=1;
        Delay500us();
		TR1=0;
        IR_OUT=1;
		Delay500us();
        IR_OUT=1;  
}
/******************************红外发射函数*******************/
void Send_Char(unsigned char add,unsigned char date)
{
        unsigned char i,j1,j2,j3,j4;
        j1=add;
         j2=~add;
        j3=date;
        j4=~date;
        Send_Start_Bit();                                                                 

  //开始数据帧
        for(i=0;i<8;i++)
        {
                if(j1&0x01)
                        Send_Bit_1();
                else
                        Send_Bit_0();
                j1=j1>>1;                                                                 

                //用户码
        }

        for(i=0;i<8;i++)
        {
                if(j2&0x01)
                        Send_Bit_1();
                else
                        Send_Bit_0();
                j2=j2>>1;                                                                 

                //用户反码
        }

        for(i=0;i<8;i++)
        {
                if(j3&0x01)
                        Send_Bit_1();
                else
                        Send_Bit_0();
                j3=j3>>1;                                                                 

                //数据码
        }
        
        for(i=0;i<8;i++)
        {
                if(j4&0x01)
                        Send_Bit_1();
                else
                        Send_Bit_0();
                j4=j4>>1;                                                                 

                //数据反码
        }
        
        Send_over();                                                                        

        //结束数据帧
}
void IR_RX_HT6121(void)
{
        u8        SampleTime;

        IR_SampleCnt++;                                                        //Sample + 1

        F0 = P_IR_RX_temp;                                                //Save Last sample status
        P_IR_RX_temp = P_IR_RX;                                        //Read current status
        if(F0 && !P_IR_RX_temp)                                        //Last sample is high,and current sample is low, so is fall edge
        {
                SampleTime = IR_SampleCnt;                        //get the sample time
                IR_SampleCnt = 0;                                        //Clear the sample counter

                         if(SampleTime > D_IR_SYNC_MAX)                B_IR_Sync = 0;        //large the Maxim SYNC time, then error
                else if(SampleTime >= D_IR_SYNC_MIN)                                        //SYNC
                {
                        if(SampleTime >= D_IR_SYNC_DIVIDE)
                        {
                                B_IR_Sync = 1;                                        //has received SYNC
                                IR_BitCnt = D_IR_BIT_NUMBER;        //Load bit number
                        }
                }
                else if(B_IR_Sync)                                                //has received SYNC
                {
                        if(SampleTime > D_IR_DATA_MAX)                B_IR_Sync=0;        //data samlpe time to large
                        else
                        {
                                IR_DataShit >>= 1;                                        //data shift right 1 bit
                                if(SampleTime >= D_IR_DATA_DIVIDE)        IR_DataShit |= 0x80;        //devide data 0 or 1
                                if(--IR_BitCnt == 0)                                //bit number is over?
                                {
                                        B_IR_Sync = 0;                                        //Clear SYNC
                                        if(~IR_DataShit == IR_data)                //???????
                                        {
                                                if((IR_UserH == (User_code / 256)) &&
                                                        IR_UserL == (User_code % 256))
                                                                B_IrUserErr = 0;        //User code is righe
                                                else        B_IrUserErr = 1;        //user code is wrong
                                                        
                                                IR_code      = IR_data;
                                                B_IR_Press   = 1;                        //????
                                        }
                                }
                                else if((IR_BitCnt & 7)== 0)                //one byte receive
                                {
                                        IR_UserL = IR_UserH;                        //Save the User code high byte
                                        IR_UserH = IR_data;                                //Save the User code low byte
                                        IR_data  = IR_DataShit;                        //Save the IR data byte
                                }
                        }
                }
        }
}