#include "SI24R1.h"

u8 code TX_ADDRESS[TX_ADR_WIDTH] = {0x0A,0x01,0x07,0x0E,0x01};  // һ̬͵ַ


static u8 SPI_RW(u8 byte)
{
	u8 bit_ctr;
	for(bit_ctr=0; bit_ctr<8; bit_ctr++)
	{
		if(byte & 0x80)
			MOSI = 1;
		else
			MOSI = 0;																 
		byte = (byte << 1);                      
		SCK = 1;                                   
		byte |= MISO;                             
		SCK = 0;                                
	}
	return(byte);                              
}


/********************************************************
ܣSI24R1ųʼ                
ڲ
  ֵ
*********************************************************/
void SI24R1_Init(void)
{
	SCK = 0; 													//SPIʱ
	CSN = 1;				
	CE 	= 0;				
	IRQ = 1;
}


/********************************************************
ܣдĴֵֽڣ                
ڲreg:ĴӳַʽWRITE_REGreg
					value:Ĵֵ
  ֵ״̬Ĵֵ
*********************************************************/
u8 SI24R1_Write_Reg(u8 reg, u8 value)
{
	u8 status;

	CSN = 0;                 
	status = SPI_RW(reg);				
	SPI_RW(value);
	CSN = 1;  
	
	return(status);
}


/********************************************************
ܣдĴֵֽڣ                  
ڲreg:ĴӳַʽWRITE_REGreg
					pBuf:д׵ַ
					bytes:дֽ
  ֵ״̬Ĵֵ
*********************************************************/
u8 SI24R1_Write_Buf(u8 reg, const u8 *pBuf, u8 bytes)
{
	u8 status,byte_ctr;

  CSN = 0;                                  			
  status = SPI_RW(reg);                          
  for(byte_ctr=0; byte_ctr<bytes; byte_ctr++)     
    SPI_RW(*pBuf++);
  CSN = 1;                                      	

  return(status);       
}							  					   


/********************************************************
ܣȡĴֵֽڣ                  
ڲreg:ĴӳַʽREAD_REGreg
  ֵĴֵ
*********************************************************/
u8 SI24R1_Read_Reg(u8 reg)
{
 	u8 value;

	CSN = 0;    
	SPI_RW(reg);			
	value = SPI_RW(0xFF);
	CSN = 1;              

	return(value);
}


/********************************************************
ܣȡĴֵֽڣ                  
ڲreg:ĴӳַREAD_REGreg
					pBuf:ջ׵ַ
					bytes:ȡֽ
  ֵ״̬Ĵֵ
*********************************************************/
u8 SI24R1_Read_Buf(u8 reg, u8 *pBuf, u8 bytes)
{
	u8 status,byte_ctr;

  CSN = 0;                                        
  status = SPI_RW(reg);                           
  for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
    pBuf[byte_ctr] = SPI_RW(0xFF);                   //ȡݣֽǰ
  CSN = 1;                                        

  return(status);    
}


/********************************************************
ܣSI24R1ģʽʼ                      
ڲ
  ֵ
*********************************************************/
void SI24R1_RX_Mode(void)
{
	CE = 0;
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);	// 豸ͨ0ʹúͷ豸ͬķ͵ַ
	SI24R1_Write_Reg(WRITE_REG + EN_AA, 0x01);               						// ʹܽͨ0ԶӦ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);           						// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);                 						// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  						// ͨ0ѡͷͨͬЧݿ
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0f);            						// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0f);              						// CRCʹܣ16λCRCУ飬ϵ磬ģʽ
	SI24R1_Write_Reg(WRITE_REG + STATUS, 0xff);  												//ежϱ־λ
	CE = 1;                                            									// CE豸
}						


/********************************************************
ܣSI24R1ģʽʼ                      
ڲ
  ֵ
*********************************************************/
void SI24R1_TX_Mode(void)
{
	CE = 0;
	SI24R1_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     // д뷢͵ַ
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // ΪӦ豸ͨ0ַͷ͵ַͬ

	SI24R1_Write_Reg(WRITE_REG + EN_AA, 0x01);       											// ʹܽͨ0ԶӦ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);   											// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + SETUP_RETR, 0x0a);  											// Զطʱȴ250us+86usԶط10
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);         											// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0f);    											// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0e);      											// CRCʹܣ16λCRCУ飬ϵ
	//CE = 1;
}


/********************************************************
ܣȡ                       
ڲrxbuf:ݴ׵ַ
  ֵ0:յ
          1:ûнյ
*********************************************************/
u8 SI24R1_RxPacket(u8 *rxbuf)
{
	u8 state;
	state = SI24R1_Read_Reg(STATUS);  			                 //ȡ״̬Ĵֵ    	  
	SI24R1_Write_Reg(WRITE_REG+STATUS,state);               //RX_DSжϱ־

	if(state & RX_DR)								                           //յ
	{
		SI24R1_Read_Buf(RD_RX_PLOAD,rxbuf,TX_PLOAD_WIDTH);     //ȡ
		SI24R1_Write_Reg(FLUSH_RX,0xff);					              //RX FIFOĴ
		return 0; 
	}	   
	return 1;                                                   //ûյκ
}


/********************************************************
ܣһݰ                      
ڲtxbuf:Ҫ͵
  ֵ0x10:ﵽطʧ 
          0x20:ͳɹ            
          0xff:ʧ                  
*********************************************************/
u8 SI24R1_TxPacket(u8 *txbuf)
{
	u8 state;
	CE=0;																										  //CEͣʹSI24R1
  SI24R1_Write_Buf(WR_TX_PLOAD, txbuf, TX_PLOAD_WIDTH);	    //дݵTX FIFO,32ֽ
 	CE=1;																										  //CEøߣʹܷ	   
	
	while(IRQ == 1);																				  //ȴ
	state = SI24R1_Read_Reg(STATUS);  											  //ȡ״̬Ĵֵ	   
	SI24R1_Write_Reg(WRITE_REG+STATUS, state); 								//TX_DSMAX_RTжϱ־
	if(state&MAX_RT)																			    //ﵽط
	{
		SI24R1_Write_Reg(FLUSH_TX,0xff);										    //TX FIFOĴ 
		return MAX_RT; 
	}
	if(state&TX_DS)																			      //
	{
		return TX_DS;
	}
	return 0XFF;																						  //ʧ
}

