#include "eeprom.h"
#include <intrins.h>
save_list xdata NEC_save_data={0}; //定义保存数据
 void IapIdle()
{
    IAP_CONTR = 0;                              //关闭IAP功能
    IAP_CMD = 0;                                //清除命令寄存器
    IAP_TRIG = 0;                               //清除触发寄存器
    IAP_ADDRH = 0x80;                           //将地址设置到非IAP区域
    IAP_ADDRL = 0;
}

char IapRead(int addr)
{
    char dat;

    IAP_CONTR = 0x80;                           //使能IAP
    IAP_TPS = 24;                               //设置等待参数24MHz
    IAP_CMD = 1;                                //设置IAP读命令
    IAP_ADDRL = addr;                           //设置IAP低地址
    IAP_ADDRH = addr >> 8;                      //设置IAP高地址
    IAP_TRIG = 0x5a;                            //写触发命令(0x5a)
    IAP_TRIG = 0xa5;                            //写触发命令(0xa5)
    _nop_();
    dat = IAP_DATA;                             //读IAP数据
    IapIdle();                                  //关闭IAP功能

    return dat;
}

void IapProgram(int addr, char dat)
{
    IAP_CONTR = 0x80;                           //使能IAP
    IAP_TPS = 24;                               //设置等待参数24MHz
    IAP_CMD = 2;                                //设置IAP写命令
    IAP_ADDRL = addr;                           //设置IAP低地址
    IAP_ADDRH = addr >> 8;                      //设置IAP高地址
    IAP_DATA = dat;                             //写IAP数据
    IAP_TRIG = 0x5a;                            //写触发命令(0x5a)
    IAP_TRIG = 0xa5;                            //写触发命令(0xa5)
    _nop_();
    IapIdle();                                  //关闭IAP功能
}

void IapErase(int addr)
{
    IAP_CONTR = 0x80;                           //使能IAP
    IAP_TPS = 24;                               //设置等待参数24MHz
    IAP_CMD = 3;                                //设置IAP擦除命令
    IAP_ADDRL = addr;                           //设置IAP低地址
    IAP_ADDRH = addr >> 8;                      //设置IAP高地址
    IAP_TRIG = 0x5a;                            //写触发命令(0x5a)
    IAP_TRIG = 0xa5;                            //写触发命令(0xa5)
    _nop_();                                    //
    IapIdle();                                  //关闭IAP功能
}

void move_read_byte(WORD addr,BYTE len,u8 *point) //给首地址
{
	u8 i;
	for(i=0;i<len;i++)
	{
		*point=*(u8 code*)(addr);
		point++;
		addr++;
	}
}
void save_data(WORD addr,BYTE len,u8 *point) //保存数据
{
	u8 i;
	IapErase(Eeprom_Write_Addr);  //0x00
	for(i=0;i<len;i++)
	{
		IapProgram(addr, *point);
		addr++;
		point++;
	}
}
void NEC_data_manage()  //初始数据处理
{
	if(NEC_save_data.distance_offset==(char)0xff)
	{
		NEC_save_data.distance_offset=0;  //偏移距离
	}
	if(NEC_save_data.stop_en==(u8)0xff)  //断光使能
	{
		NEC_save_data.stop_en=0;
	}
	if(NEC_save_data.distance_min==(int)0xffff) //min
	{
		NEC_save_data.distance_min=0;
	}
	if(NEC_save_data.distance_max==(int)0xffff) //max
	{
		NEC_save_data.distance_max=0;
	}
	if(NEC_save_data.temp_min==(int)0xffff) //温度下限
	{
		NEC_save_data.temp_min=0;
	}
	if(NEC_save_data.temp_max==(int)0xffff) //温度上限
	{
		NEC_save_data.temp_max=0;
	}
}
	