#ifndef     __I2CH_H__
#define     __I2CH_H__
#include "STC8h.h"
#define	I2C_USE_P14P15()	P_SW2 &= ~0x30						/* I2CлP1.4(SDA) P1.5(SCL)(ϵĬ).*/
#define	I2C_USE_P24P25()	P_SW2  = (P_SW2 & ~0x30) | 0x10		/* I2CлP2.4(SDA) P2.5(SCL).*/
#define	I2C_USE_P76P77()	P_SW2  = (P_SW2 & ~0x30) | 0x20		/* I2CлP7.6(SDA) P7.7(SCL).*/
#define	I2C_USE_P33P32()	P_SW2 |= 0x30						/* I2CлP3.3(SDA) P3.2(SCL).*/
//sfr I2CCFG = 0xFE80H;  ENI2C MSSL             MSSPEED[5:0]             0000,0000  /* I2CüĴ */ 
#define		I2C_Function(n)	(n==0?(I2CCFG &= ~0x80):(I2CCFG |= 0x80))	//0ֹ I2C ܣ1ʹ I2C 
#define		I2C_ENABLE()	I2CCFG |= 0x80		/* ʹ I2C  */
#define		I2C_DISABLE()	I2CCFG &= ~0x80		/* ֹ I2C  */
#define		I2C_Master()	I2CCFG |=  0x40		/* 1: Ϊ	*/
#define		I2C_Slave()		I2CCFG &= ~0x40		/* 0: Ϊӻ	*/
#define		I2C_SetSpeed(n)	I2CCFG = (I2CCFG & ~0x3f) | (n & 0x3f)	/* ٶ=Fosc/2/(Speed*2+4) */

//						              7    6     5     4     3     2     1     0    Reset Value
//sfr I2CMSCR = 0xFE81H;  EMSI   -     -     -         MSCMD[3:0]         0000,0000  /* I2CüĴ */ 
#define		I2C_Master_Inturrupt(n)	(n==0?(I2CMSCR &= ~0x80):(I2CMSCR |= 0x80))	//0ֹ I2C ܣ1ʹ I2C 

#define	I2C_CMD_None				0
#define	I2C_CMD_Start				1
#define	I2C_CMD_Send				2
#define	I2C_CMD_RACK				3
#define	I2C_CMD_Read				4
#define	I2C_CMD_SACK				5
#define	I2C_CMD_Stop				6
#define	I2C_CMD_RFU1				7
#define	I2C_CMD_RFU2				8
#define	I2C_CMD_Start_Send_RACK		9
#define	I2C_CMD_Send_RACK					10
#define	I2C_CMD_Read_SACK					11
#define	I2C_CMD_Read_SNAK					12

#define		I2C_Command(n)	I2CMSCR = (I2CMSCR & ~0x0f) | (n & 0x0f)	/*  */

#define		I2C_WDTA_EN()		I2CMSAUX |= 0x01		/* ʹԶ */
#define		I2C_WDTA_DIS()	I2CMSAUX &= ~0x01		/* ֹԶ */

//						             7     6     5     4     3     2    1    0       Reset Value
//sfr I2CSLCR = 0xFE83H;   -   ESTAI  ERXI  ETXI ESTOI   -    -  SLRET     0000,0000  /* I2CӻƼĴ */ 
#define		I2C_ESTAI_EN()		I2CSLCR |= 0x40			/* ʹܴӻSTARTźж */
#define		I2C_ESTAI_DIS()		I2CSLCR &= ~0x40		/* ֹӻSTARTźж */
#define		I2C_ERXI_EN()			I2CSLCR |= 0x20			/* ʹܴӻ1ֽж */
#define		I2C_ERXI_DIS()		I2CSLCR &= ~0x20		/* ֹӻ1ֽж */
#define		I2C_ETXI_EN()			I2CSLCR |= 0x10			/* ʹܴӻ1ֽж */
#define		I2C_ETXI_DIS()		I2CSLCR &= ~0x10		/* ֹӻ1ֽж */
#define		I2C_ESTOI_EN()		I2CSLCR |= 0x08			/* ʹܴӻSTOPźж */
#define		I2C_ESTOI_DIS()		I2CSLCR &= ~0x08		/* ֹӻSTOPźж */
#define		I2C_SLRET()				I2CSLCR |= 0x01			/* λӻģʽ */

//						               7      6     5     4     3     2      1     0        Reset Value
//sfr I2CSLST = 0xFE84H;  SLBUSY  STAIF  RXIF  TXIF STOIF   -   SLACKI SLACKO     0000,0000  /* I2Cӻ״̬Ĵ */ 

//						              7    6     5     4     3     2     1     0      Reset Value
//sfr I2CSLADR = 0xFE85H;              I2CSLADR[7:1]                 MA     0000,0000  /* I2CӻַĴ */ 
#define		I2C_Address(n)	I2CSLADR = (I2CSLADR & 0x01) | (n << 1)	/* ӻַ */
#define		I2C_MATCH_EN()	I2CSLADR &= ~0x01	/* ʹܴӻַȽϹܣֻƥַ */
#define		I2C_MATCH_DIS()	I2CSLADR |= 0x01	/* ֹӻַȽϹܣ豸ַ */

void start();
void stop();
void ack();
void i2c_write(u8 dat);
u8 i2c_read();
void i2cinit(); 
void SendACK();
void SendNAK();
#endif
