#include "STC8h.h"
#include "uart.h"
#include "delay.h"
#include "vl53l0x.h"
#include "stdio.h"
#include "i2c.h"
#include "IR_RED.h"
#include "eeprom.h"
#include "tm1638.h"
#include "timer.h"
#include "AHT10.h"
#define  P_num   19  //P
#define  Clear    21  //
#define  Minus    22  //-
#define  st_led   P00 //
#define  st_beep  P01//
/*******************函数声明**/
void  gpio_init();
void io_scan();
void out_init();  //输出初始化
void sys_init();
xdata unsigned char buf[30];
xdata unsigned int val = 0;
xdata u8  ir_data[4]={0};//红外解码
xdata u8  sys_mode=0;//系统当前状态
xdata u8  ir_hex_str[20]={0};
xdata u16 distance_sum=0;
xdata u16 distance_buff[15]={0};
xdata u8 distacne_index=0;
xdata u8 distance_fill_f=0;
xdata u16 distance_sub=0;
xdata u8 page_index=0 ;//页索引
xdata u8  P_index=0;//p段索引
xdata u8  bit_Num[6]={0}; //位数
xdata u8 eeprom_save_f=0;//掉电数据保存标志
xdata u8 AHT10_delay=0;//aht10计时时间
xdata u8 AHT10_delay_en=0;//aht10计时使能
xdata u8 AHT10_READ_buff[6]={0};
xdata long int AHT10_HUM=0;
xdata long int AHT10_TEMP=0;
xdata float AHT10_TEMP_f=0;
xdata u8 distacne_f=0; //距离检索标志 
xdata u8 temp_f=0;  //温度检索标志
xdata u16 period_cut=0;//周期计时
xdata u8  period_distance=0;
void distance_temp_data_gather(); //距离数据采集
void temp_data_gather();//温度数据采集
void P_data_set();//p段数据设置
void P_index_show(u8,int);//P段索引显示
void threshold_check();//阈值判定
void P_00();//P段参数具体设置
void P_01();
void P_02();
void P_03();
void P_04();
void P_05();
void P_06();
void main()
{
	 i2cinit();
   sys_init();  //系统初始化
	 UartInit();
	 PWMA_INIT();
	 move_read_byte(Eeprom_Read_Addr,sizeof(save_list),(u8 *)&NEC_save_data);  //读取保存数据
	 NEC_data_manage();
	 timer0_init(65536-2000); //定时1ms
	 delay_ms(200);
	 AHT10_INIT();//初始化
	 delay_ms(10);
	 AHT10_RST();
	//以下分别读0xc0,0xc1,0xc2寄存器的值，读出来应该是0xEE,0xAA,0x10
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID-2);
	sprintf(buf,"c0=%x\r\n",val);
	UartSendStr(buf);
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID-1);
	sprintf(buf,"c1=%x\r\n",val);
	UartSendStr(buf);
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID);
	sprintf(buf,"c2=%x\r\n",val);
	UartSendStr(buf);
	VL53L0X_init(1);
	startContinuous(0);
	

	 while(1)
	 {
		u8 i;
			if(sys_mode==0) //采集模式
			{
				if(0<period_cut&&period_cut<8000)
				{
					sprintf(ir_hex_str,"%04d",distance_sub);
					for(i=0;i<4;i++)
				 {
					 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
					 {
						 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
					 }
					 else
					 {
						 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
					 }
				 } 
					I2C_USE_P24P25();
					tm1638_write_display(tm1638_show_buff);
					I2C_USE_P14P15(); 	
				}
				if(period_cut>=8000&&period_cut<=9999)
				{
						sprintf(ir_hex_str,"%04d",(int)(AHT10_TEMP_f));
					 for(i=0;i<4;i++)
					 {
						 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
						 {
							 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
						 }
						 else
						 {
							 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
						 }
					 }
					 tm1638_show_buff[1]=tm1638_show_buff[1]|0x80;
						I2C_USE_P24P25();
						tm1638_write_display(tm1638_show_buff);
						I2C_USE_P14P15();
				}	
				 if(period_distance>20)
				 {
					 period_distance=0;
					 distance_temp_data_gather();//距离显示
				 }
				temp_data_gather(); //温度显示
			}		 
		 if(B_IR_Press)
		 {
			u8 i=0;
			B_IR_Press=0;
			flow_index=0;
		   ir_data[0]=((u8 *)&RmtNec)[0];
			 ir_data[1]=((u8 *)&RmtNec)[1];
			 ir_data[2]=((u8 *)&RmtNec)[2];
			 ir_data[3]=((u8 *)&RmtNec)[3];
			 /***** 使用数码管显示nec码
			 sprintf(ir_hex_str,"%02X%02X%02X%02X\r\n",RmtNec);
			 for(i=0;i<4;i++)
			 {
				 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
				 }
				 else
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
				 }
			 }
			 	I2C_USE_P24P25();
				tm1638_write_display(tm1638_show_buff);
				I2C_USE_P14P15();
				*****/
		 }
		 P_data_set();
		 threshold_check();
	 }
  
}
void timer0_inter()  interrupt 1       //t0定时器中断
{
  if(AHT10_delay_en==1&&AHT10_delay<100)
	{
		AHT10_delay++;
	}
	period_cut++;
	if(period_cut>=10000)  //周期tick
	{
		period_cut=0;
	}
	period_distance++;
}
void  INIT0()  interrupt 0   //外部中断
{
	    
			
}
void  gpio_init()
{

}
void io_scan()   //执行按键
{

}


void sys_init()
{
    P_SW2 |= 0x80;     //扩展寄存器(XFR)访问使能

    P0M1 = 0x00;   P0M0 = 0x03;   //设置为准双向口p00 01推完输出
    P1M0 = 0x3f; P1M1 = 0x3f; 
    P2M1 = 0x30;   P2M0 = 0x30; 
    P3M1 = 0x04;   P3M0 = 0x04;   //设置为准双向口  
    P4M1 = 0x14;   P4M0 = 0x00;   //设置为准双向口
    P5M1 = 0x00;   P5M0 = 0x00;   //设置为准双向口
    P6M1 = 0x00;   P6M0 = 0x00;   //设置为准双向口
    P7M1 = 0x00;   P7M0 = 0x00;   //设置为准双向口
	
	  IT0 = 1;                                    //使能INT0下降沿中断
    EX0 = 0; 
}
void distance_temp_data_gather()//数据采集函数
{
	u8 i;
		val = readRangeContinuousMillimeters();
		/*距离数据滤波*/ 
		 distance_sum=0;
		if(distance_fill_f==0)
		{
			if(val<500)
			{
				distance_buff[distacne_index]=val+NEC_save_data.distance_offset;
				distacne_index++;
				for(i=0;i<distacne_index;i++)
				{
					distance_sum=distance_sum+distance_buff[i];
				}
				distance_sub=distance_sum/distacne_index;//平均值
				if(distacne_index==15)
				{
					distance_fill_f=1;
					distacne_index=0;
				}
			}
		}
		else
		{
			if(val<500)
			{
				distance_buff[distacne_index]=val+NEC_save_data.distance_offset;
				distacne_index++;
				distance_sum=0;
				for(i=0;i<15;i++)
				{
					distance_sum=distance_sum+distance_buff[i];
				}
				distance_sub=distance_sum/15;//平均值
				if(distacne_index==15)
				{
					distacne_index=0;
				}
			}
		}
		/*距离数据滤波*/ 
//		sprintf(ir_hex_str,"%04d",distance_sub);
//		 for(i=0;i<4;i++)
//			 {
//				 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
//				 {
//					 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
//				 }
//				 else
//				 {
//					 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
//				 }
//			 } 
//    I2C_USE_P24P25();
//		tm1638_write_display(tm1638_show_buff);
//		I2C_USE_P14P15(); 	
}
void temp_data_gather() //温度采集
{
if(AHT10_delay_en==0)
{
	AHT10_delay_en=1;
	AHT10_Measure();
	AHT10_delay=0;
}
if(AHT10_delay>=85)
{
	u8 i;
	while(AHT10_STATUS()&0x80);
	AHT10_TEMP=0;
	AHT10_READ_HUM_Temp(AHT10_READ_buff);
	AHT10_delay_en=0;
	AHT10_TEMP=((AHT10_READ_buff[3]&0x0f)|(long int)0x00)<<16;
	AHT10_TEMP=AHT10_TEMP|((AHT10_READ_buff[4]|(long int)0x00)<<8);
	AHT10_TEMP=AHT10_TEMP+AHT10_READ_buff[5];
	AHT10_TEMP_f=((int)(AHT10_TEMP*2000.0/1024/1024))/10.0-50;
//	sprintf(ir_hex_str,"%04d",(int)(AHT10_TEMP_f));
//	 for(i=0;i<4;i++)
//	 {
//		 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
//		 {
//			 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
//		 }
//		 else
//		 {
//			 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
//		 }
//	 }
//		I2C_USE_P24P25();
//		tm1638_write_display(tm1638_show_buff);
//		I2C_USE_P14P15();
 }
/*******温湿度数据采集******/
}
void threshold_check() //阈值判定
{
	if(sys_mode==0)
	{
		if(NEC_save_data.distance_min<=distance_sub&&distance_sub<=NEC_save_data.distance_max)
		{
			distacne_f=0;
		}
		else
		{
			distacne_f=1;
		}
		if(NEC_save_data.temp_min<=(int)AHT10_TEMP_f&&(int)AHT10_TEMP_f<=NEC_save_data.temp_max)
		{
			temp_f=0;
		}
		else
		{
			temp_f=1;
		}
		if((temp_f|distacne_f)&NEC_save_data.stop_en)
		{
			st_led=1;
			st_beep=0;
		}
		else
		{
			st_led=0;
			st_beep=1;
		}
	}
	else
	{
		st_led=1;
		st_beep=1;
	}
}
void P_data_set()
{
	if(ir_data[1]==0x1C) //参数设置与数据采集页面切换 OK
	{
		ir_data[1]=0;
		if(sys_mode==0)
		{
			sys_mode=1;
			page_index=0;
			//显示P段参数列表 P000
			P_index_show(P_num,page_index);
		}
		else
		{
			sys_mode=0;
		}
	}
	if(ir_data[1]==0x18)//up P
	{
		ir_data[1]=0;
		if(sys_mode==1)
		{
			if(page_index<6)//上限P006
			{
				page_index++;
				P_index_show(P_num,page_index);
			}
		}
	}
	
	if(ir_data[1]==0x52)//down P
	{
		ir_data[1]=0;
		if(sys_mode==1)
		{
			if(page_index>0)  //下限P00
			{
				page_index--;
				P_index_show(P_num,page_index);
			}
		}
	}
	
	if(ir_data[1]==0x5a) //R进入具体参数设置详情页面
	{
		ir_data[1]=0;
		if(sys_mode==1)
		{
			sys_mode=2;
		}
	}
	if(ir_data[1]==0x08) //L 进入P段索引页面
	{
		ir_data[1]=0;
		if(sys_mode==2)
		{
			sys_mode=1;
			P_index_show(P_num,page_index);
		}
	}
		if(sys_mode==2)
	{
			switch(page_index)
		{
			case 0:P_00(); break;
			case 1:P_01(); break;
			case 2:P_02(); break;
			case 3:P_03(); break;
			case 4:P_04(); break;
			case 5:P_05();break;
			case 6:P_06();break;
			default : break;
		}
	}
}
void P_index_show(u8 first_num, int content)
{
	u8 i;
	tm1638_show_buff[0]=tab[first_num];//P
	sprintf(ir_hex_str,"%04d",(int)content);
	for(i=1;i<4;i++)
	 {
		 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
		 {
			 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
		 }
		 else
		 {
			 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
		 }
	 } 
		I2C_USE_P24P25();
		tm1638_write_display(tm1638_show_buff);
		I2C_USE_P14P15(); 	
}
void data_content_show()  //详细数据内容显示
{
	u8 i;
	sprintf(ir_hex_str,"%04d",(int)page_index);
	for(i=0;i<4;i++)
	 {
		 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
		 {
			 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
		 }
		 else
		 {
			 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
		 }
	 } 
		I2C_USE_P24P25();
		tm1638_write_display(tm1638_show_buff);
		I2C_USE_P14P15(); 	
}
void P_00()
{
	
	if(ir_data[1]==0x45)
	{
		NEC_save_data.distance_offset+=1;
		if(NEC_save_data.distance_offset>99) NEC_save_data.distance_offset=99; //增加上限
	}
	if(ir_data[1]==0x46)
	{
		NEC_save_data.distance_offset+=10;
		if(NEC_save_data.distance_offset>99) NEC_save_data.distance_offset=99;
	}
  if(ir_data[1]==0x44)
	{
		NEC_save_data.distance_offset-=1;
		if(NEC_save_data.distance_offset<-99) NEC_save_data.distance_offset=-99;//减少下限
	}
	if(ir_data[1]==0x40)
	{
		NEC_save_data.distance_offset-=10;
		if(NEC_save_data.distance_offset<-99) NEC_save_data.distance_offset=-99;
	}
  if(NEC_save_data.distance_offset<0)
	{
			P_index_show(Minus,NEC_save_data.distance_offset);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.distance_offset);
	}
	ir_data[1]=0;
}
void P_01()
{
	if(ir_data[1]==0x45)
	{
		NEC_save_data.stop_en=1;
	}
	
  if(ir_data[1]==0x44)
	{
		NEC_save_data.stop_en=0;
	}
  if(NEC_save_data.stop_en<0)
	{
			P_index_show(Minus,NEC_save_data.stop_en);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.stop_en);
	}
	ir_data[1]=0;
}
void P_02()//距离下限
{
	if(ir_data[1]==0x45)
	{
		NEC_save_data.distance_min+=1;
		if(NEC_save_data.distance_min>300) NEC_save_data.distance_min=300; //增加上限
	}
	if(ir_data[1]==0x46)
	{
		NEC_save_data.distance_min+=10;
		if(NEC_save_data.distance_min>300) NEC_save_data.distance_min=300;
	}
	if(ir_data[1]==0x47)
	{
		NEC_save_data.distance_min+=100;
		if(NEC_save_data.distance_min>300) NEC_save_data.distance_min=300;
	}
  if(ir_data[1]==0x44)
	{
		NEC_save_data.distance_min-=1;
		if(NEC_save_data.distance_min<0) NEC_save_data.distance_min=0;//减少下限
	}
	if(ir_data[1]==0x40)
	{
		NEC_save_data.distance_min-=10;
		if(NEC_save_data.distance_min<0) NEC_save_data.distance_min=0;
	}
	if(ir_data[1]==0x43)
	{
		NEC_save_data.distance_min-=100;
		if(NEC_save_data.distance_min<0) NEC_save_data.distance_min=0;
	}
  if(NEC_save_data.distance_min<0)
	{
			P_index_show(Minus,NEC_save_data.distance_min);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.distance_min);
	}
	ir_data[1]=0;
}
void P_03()
{
	if(ir_data[1]==0x45)
	{
		NEC_save_data.distance_max+=1;
		if(NEC_save_data.distance_max>300) NEC_save_data.distance_max=300; //增加上限
	}
	if(ir_data[1]==0x46)
	{
		NEC_save_data.distance_max+=10;
		if(NEC_save_data.distance_max>300) NEC_save_data.distance_max=300;
	}
	if(ir_data[1]==0x47)
	{
		NEC_save_data.distance_max+=100;
		if(NEC_save_data.distance_max>300) NEC_save_data.distance_max=300;
	}
  if(ir_data[1]==0x44)
	{
		NEC_save_data.distance_max-=1;
		if(NEC_save_data.distance_max<0) NEC_save_data.distance_max=0;//减少下限
	}
	if(ir_data[1]==0x40)
	{
		NEC_save_data.distance_max-=10;
		if(NEC_save_data.distance_max<0) NEC_save_data.distance_max=0;
	}
	if(ir_data[1]==0x43)
	{
		NEC_save_data.distance_max-=100;
		if(NEC_save_data.distance_max<0) NEC_save_data.distance_max=0;
	}
  if(NEC_save_data.distance_max<0)
	{
			P_index_show(Minus,NEC_save_data.distance_max);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.distance_max);
	}
	ir_data[1]=0;
}
void P_04()
{
	if(ir_data[1]==0x45)
	{
		NEC_save_data.temp_min+=1;
		if(NEC_save_data.temp_min>100) NEC_save_data.temp_min=100; //增加上限
	}
	if(ir_data[1]==0x46)
	{
		NEC_save_data.temp_min+=10;
		if(NEC_save_data.temp_min>100) NEC_save_data.temp_min=100;
	}
	if(ir_data[1]==0x47)
	{
		NEC_save_data.temp_min+=100;
		if(NEC_save_data.temp_min>100) NEC_save_data.temp_min=100;
	}
  if(ir_data[1]==0x44)
	{
		NEC_save_data.temp_min-=1;
		if(NEC_save_data.temp_min<-30) NEC_save_data.temp_min=-30;//减少下限
	}
	if(ir_data[1]==0x40)
	{
		NEC_save_data.temp_min-=10;
		if(NEC_save_data.temp_min<-30) NEC_save_data.temp_min=-30;
	}
	if(ir_data[1]==0x43)
	{
		NEC_save_data.temp_min-=100;
		if(NEC_save_data.temp_min<-30) NEC_save_data.temp_min=-30;
	}
  if(NEC_save_data.temp_min<0)
	{
			P_index_show(Minus,NEC_save_data.temp_min);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.temp_min);
	}
	ir_data[1]=0;
}
void P_05()
{
	if(ir_data[1]==0x45)
	{
		NEC_save_data.temp_max+=1;
		if(NEC_save_data.temp_max>100) NEC_save_data.temp_max=100; //增加上限
	}
	if(ir_data[1]==0x46)
	{
		NEC_save_data.temp_max+=10;
		if(NEC_save_data.temp_max>100) NEC_save_data.temp_max=100;
	}
	if(ir_data[1]==0x47)
	{
		NEC_save_data.temp_max+=100;
		if(NEC_save_data.temp_max>100) NEC_save_data.temp_max=100;
	}
  if(ir_data[1]==0x44)
	{
		NEC_save_data.temp_max-=1;
		if(NEC_save_data.temp_max<-30) NEC_save_data.temp_max=-30;//减少下限
	}
	if(ir_data[1]==0x40)
	{
		NEC_save_data.temp_max-=10;
		if(NEC_save_data.temp_max<-30) NEC_save_data.temp_max=-30;
	}
	if(ir_data[1]==0x43)
	{
		NEC_save_data.temp_max-=100;
		if(NEC_save_data.temp_max<-30) NEC_save_data.temp_max=-30;
	}
  if(NEC_save_data.temp_max<0)
	{
			P_index_show(Minus,NEC_save_data.temp_max);
	}
	else
	{
			P_index_show(Clear,NEC_save_data.temp_max);
	}
	ir_data[1]=0;
}
void P_06()
{
	if(eeprom_save_f==0)
	{
		eeprom_save_f=1;
		P_index_show(Minus,0);
	}
	if(ir_data[1]==0x45)
	{
		ir_data[1]=0;
		save_data(Eeprom_Write_Addr,sizeof(save_list),(u8 *)&NEC_save_data) ;//保存数据
		P_index_show(Minus,111);
		delay_ms(1000);
		eeprom_save_f=0;
	}
}